import 'package:flutter/material.dart';
import 'package:flutter_appauth/flutter_appauth.dart';

import 'base.dart';

class Okta extends AuthenticationBase {
  final String redirectUrl;
  final String clientId;
  final String discoveryUrl;
  FlutterAppAuth appAuth = FlutterAppAuth();
  Okta({
    required this.redirectUrl,
    required this.clientId,
    required this.discoveryUrl,
  });
  @override
  Widget authorize(BuildContext context) {
    return const CircularProgressIndicator();
  }

  @override
  Future<String?> getAccessToken() async {
    final AuthorizationTokenResponse? result =
        await appAuth.authorizeAndExchangeCode(
      AuthorizationTokenRequest(
        clientId,
        redirectUrl,
        discoveryUrl: discoveryUrl,
        scopes: ['openid', 'profile', 'email'],
      ),
    );
    return result?.accessToken;
  }
}
