import 'package:location/location.dart';

class Location {
  late double lat;
  late double lng;
}

class Address {
  final String address;
  final String placeId;
  final Iterable<String>? types;
  Address.fromJson(Map<String, dynamic> json)
      : this(json['description'], json['place_id'], List.from(json['types']));

  Address(this.address, this.placeId, this.types);
}

class BusinessInfo {
  final String name;
  final String placeId;
  final Iterable<String>? types;
  final LatLng location;
  final String? address;
  BusinessInfo.fromJson(Map<String, dynamic> json)
      : this(json['name'], json['place_id'], List.from(json['types']),
            LatLng.fromJson(json['geometry']['location']), json['vicinity']);

  BusinessInfo(
      this.name, this.placeId, this.types, this.location, this.address);
}

class LatLng {
  final Map<String, dynamic> _json;

  double get latitude => _json['lat'];
  double get longitude => _json['lng'];

  Map<String, dynamic> asJson() => _json;

  LatLng(this._json);
  LatLng.fromJson(Map<String, dynamic> json) : this(json);
  LatLng.from(LocationData data)
      : _json = {'lat': data.latitude, 'lng': data.longitude};
}
