import 'package:bizdoc/models/profile.dart';

import 'base.dart';

class Users extends Service {
  final _cacheUserInfo = {};

  /// List users filtered by [name]
  Future<Iterable<UserInfo>> findAll(String name, {int? take}) async {
    final response =
        await dio.get('/account/list', queryParameters: {'name': name});
    return (response.data as List).map((e) => UserInfo.fromJson(e));
  }

  /// Find a user by [id]
  Future<UserInfo> find(String id) async {
    if (_cacheUserInfo.containsKey(id)) return await _cacheUserInfo[id];

    final response = await dio.get('/account/info/$id');

    return _cacheUserInfo[id] = UserInfo.fromJson(response.data);
  }
}

/// Singleton access users api
final users = Users();
