import '../models/chat.dart';

import 'base.dart';
import 'session.dart';

class ChatService extends Service {
  Future<Chat> chat(String contactId,
      {String? text, Map<String, dynamic>? resource}) async {
    final response = await dio
        .post('/chat/$contactId', data: {'resource': resource, 'text': text});
    return Chat.fromJson(response.data);
  }

  Future<Iterable<Chat>> conversation(String contactId,
      {DateTime? before, int? take}) async {
    final Map<String, dynamic> queryParameters = {};
    if (before != null) queryParameters['before'] = before.toIso8601String();
    final response =
        await dio.get('/chat/$contactId', queryParameters: queryParameters);
    return (response.data as List).map((e) => Chat.fromJson(e));
  }

  Future typing(String contactId) => dio.put('/chat/typing/$contactId');
  Future seen(String contactId) async {
    await dio.put('/chat/seen/$contactId');
    session.profile.conversationsCount--;
  }
}

final chat = ChatService();
