import 'base.dart';

class DataSource extends Service {
  final _cacheDataSources = {};

  /// Retrieve _datatype_ values by [name]
  Future<Map<String, dynamic>> map(String name) async {
    if (_cacheDataSources.containsKey(name)) {
      final data = await _cacheDataSources[name];
      return data;
    }
    final response = await dio.get('/datatype/$name');

    return _cacheDataSources[name] = response.data;
  }
}

final dataSource = DataSource();
